/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "cfg_file.y"

/*  
    VTun - Virtual Tunnel over TCP/IP network.

    Copyright (C) 1998-2016  Maxim Krasnyansky <max_mk@yahoo.com>

    VTun has been derived from VPPP package by Maxim Krasnyansky. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 */

/*
 * $Id: cfg_file.y,v 1.8.2.8 2016/10/01 21:27:51 mtbishop Exp $
 */ 

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include <syslog.h>

#include "compat.h"
#include "vtun.h"
#include "lib.h"

int lineno = 1;

struct vtun_host *parse_host;
extern struct vtun_host default_host;

llist  *parse_cmds;
struct vtun_cmd parse_cmd;

llist host_list;

int  cfg_error(const char *fmt, ...);
int  add_cmd(llist *cmds, char *prog, char *args, int flags);
void *cp_cmd(void *d, void *u);
int  free_cmd(void *d, void *u);

void copy_addr(struct vtun_host *to, struct vtun_host *from);
int  free_host(void *d, void *u);
void free_addr(struct vtun_host *h);
void free_host_list(void);

int  parse_syslog(char *facility);

int yyparse(void);
int yylex(void);	
int yyerror(char *s); 

#define YYERROR_VERBOSE 1


#line 137 "cfg_file.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cfg_file.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_K_OPTIONS = 3,                  /* K_OPTIONS  */
  YYSYMBOL_K_DEFAULT = 4,                  /* K_DEFAULT  */
  YYSYMBOL_K_PORT = 5,                     /* K_PORT  */
  YYSYMBOL_K_BINDADDR = 6,                 /* K_BINDADDR  */
  YYSYMBOL_K_PERSIST = 7,                  /* K_PERSIST  */
  YYSYMBOL_K_TIMEOUT = 8,                  /* K_TIMEOUT  */
  YYSYMBOL_K_PASSWD = 9,                   /* K_PASSWD  */
  YYSYMBOL_K_PROG = 10,                    /* K_PROG  */
  YYSYMBOL_K_PPP = 11,                     /* K_PPP  */
  YYSYMBOL_K_SPEED = 12,                   /* K_SPEED  */
  YYSYMBOL_K_IFCFG = 13,                   /* K_IFCFG  */
  YYSYMBOL_K_FWALL = 14,                   /* K_FWALL  */
  YYSYMBOL_K_ROUTE = 15,                   /* K_ROUTE  */
  YYSYMBOL_K_DEVICE = 16,                  /* K_DEVICE  */
  YYSYMBOL_K_MULTI = 17,                   /* K_MULTI  */
  YYSYMBOL_K_SRCADDR = 18,                 /* K_SRCADDR  */
  YYSYMBOL_K_IFACE = 19,                   /* K_IFACE  */
  YYSYMBOL_K_ADDR = 20,                    /* K_ADDR  */
  YYSYMBOL_K_TYPE = 21,                    /* K_TYPE  */
  YYSYMBOL_K_PROT = 22,                    /* K_PROT  */
  YYSYMBOL_K_NAT_HACK = 23,                /* K_NAT_HACK  */
  YYSYMBOL_K_COMPRESS = 24,                /* K_COMPRESS  */
  YYSYMBOL_K_ENCRYPT = 25,                 /* K_ENCRYPT  */
  YYSYMBOL_K_KALIVE = 26,                  /* K_KALIVE  */
  YYSYMBOL_K_STAT = 27,                    /* K_STAT  */
  YYSYMBOL_K_SSLAUTH = 28,                 /* K_SSLAUTH  */
  YYSYMBOL_K_UP = 29,                      /* K_UP  */
  YYSYMBOL_K_DOWN = 30,                    /* K_DOWN  */
  YYSYMBOL_K_SYSLOG = 31,                  /* K_SYSLOG  */
  YYSYMBOL_K_IPROUTE = 32,                 /* K_IPROUTE  */
  YYSYMBOL_K_HOST = 33,                    /* K_HOST  */
  YYSYMBOL_K_ERROR = 34,                   /* K_ERROR  */
  YYSYMBOL_WORD = 35,                      /* WORD  */
  YYSYMBOL_PATH = 36,                      /* PATH  */
  YYSYMBOL_STRING = 37,                    /* STRING  */
  YYSYMBOL_NUM = 38,                       /* NUM  */
  YYSYMBOL_DNUM = 39,                      /* DNUM  */
  YYSYMBOL_40_n_ = 40,                     /* '\n'  */
  YYSYMBOL_41_ = 41,                       /* '{'  */
  YYSYMBOL_42_ = 42,                       /* '}'  */
  YYSYMBOL_YYACCEPT = 43,                  /* $accept  */
  YYSYMBOL_config = 44,                    /* config  */
  YYSYMBOL_statement = 45,                 /* statement  */
  YYSYMBOL_46_1 = 46,                      /* $@1  */
  YYSYMBOL_47_2 = 47,                      /* $@2  */
  YYSYMBOL_options = 48,                   /* options  */
  YYSYMBOL_option = 49,                    /* option  */
  YYSYMBOL_bindaddr_option = 50,           /* bindaddr_option  */
  YYSYMBOL_syslog_opt = 51,                /* syslog_opt  */
  YYSYMBOL_host_options = 52,              /* host_options  */
  YYSYMBOL_host_option = 53,               /* host_option  */
  YYSYMBOL_54_3 = 54,                      /* $@3  */
  YYSYMBOL_55_4 = 55,                      /* $@4  */
  YYSYMBOL_56_5 = 56,                      /* $@5  */
  YYSYMBOL_57_6 = 57,                      /* $@6  */
  YYSYMBOL_compress = 58,                  /* compress  */
  YYSYMBOL_keepalive = 59,                 /* keepalive  */
  YYSYMBOL_srcaddr_options = 60,           /* srcaddr_options  */
  YYSYMBOL_srcaddr_option = 61,            /* srcaddr_option  */
  YYSYMBOL_command_options = 62,           /* command_options  */
  YYSYMBOL_command_option = 63,            /* command_option  */
  YYSYMBOL_64_7 = 64,                      /* $@7  */
  YYSYMBOL_prog_options = 65,              /* prog_options  */
  YYSYMBOL_prog_option = 66                /* prog_option  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   198

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  43
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  24
/* YYNRULES -- Number of rules.  */
#define YYNRULES  89
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  144

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   294


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      40,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    41,     2,    42,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    86,    86,    87,    90,    91,    93,    93,    98,    98,
     132,   139,   140,   144,   145,   150,   152,   157,   162,   167,
     172,   177,   182,   187,   192,   194,   201,   206,   211,   216,
     223,   227,   234,   241,   242,   247,   248,   253,   258,   262,
     266,   274,   283,   283,   288,   295,   303,   303,   308,   315,
     322,   327,   332,   341,   343,   343,   348,   348,   353,   360,
     367,   372,   379,   384,   392,   398,   399,   400,   404,   410,
     416,   422,   426,   432,   433,   434,   437,   438,   438,   446,
     451,   456,   461,   466,   471,   478,   479,   483,   487,   491
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "K_OPTIONS",
  "K_DEFAULT", "K_PORT", "K_BINDADDR", "K_PERSIST", "K_TIMEOUT",
  "K_PASSWD", "K_PROG", "K_PPP", "K_SPEED", "K_IFCFG", "K_FWALL",
  "K_ROUTE", "K_DEVICE", "K_MULTI", "K_SRCADDR", "K_IFACE", "K_ADDR",
  "K_TYPE", "K_PROT", "K_NAT_HACK", "K_COMPRESS", "K_ENCRYPT", "K_KALIVE",
  "K_STAT", "K_SSLAUTH", "K_UP", "K_DOWN", "K_SYSLOG", "K_IPROUTE",
  "K_HOST", "K_ERROR", "WORD", "PATH", "STRING", "NUM", "DNUM", "'\\n'",
  "'{'", "'}'", "$accept", "config", "statement", "$@1", "$@2", "options",
  "option", "bindaddr_option", "syslog_opt", "host_options", "host_option",
  "$@3", "$@4", "$@5", "$@6", "compress", "keepalive", "srcaddr_options",
  "srcaddr_option", "command_options", "command_option", "$@7",
  "prog_options", "prog_option", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
      10,   123,   125
};
#endif

#define YYPACT_NINF (-76)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -76,     0,   -76,   -20,   -76,   -76,   -76,   -76,   -76,    99,
     -15,   -12,   -24,    -9,    16,    39,    52,    53,    64,    65,
      63,   -27,    70,   -76,   -76,     4,   -76,   120,   120,   -76,
     -14,   -76,   -76,   -76,   -76,   -76,   -76,   -76,   -76,   -76,
     -76,   -76,   -76,   -76,   -76,    77,    78,    73,   -37,    82,
      81,    80,    84,    85,    86,   -76,    87,   -76,    88,    96,
     -76,   -76,   -76,   -76,    40,   -76,    69,   -13,   100,   -76,
      98,   -76,   -76,   -76,   -76,   -76,   -76,   -76,    11,   -76,
     -76,   -76,    21,   -76,    45,   -76,   -76,   110,   117,   -76,
     -76,   -76,   -76,   -76,   -76,   -76,   121,     2,   128,   -76,
       8,   -76,   -76,   -76,   -76,   -76,   -76,   -76,   -76,   -76,
     158,   158,   -76,   -76,   -76,   -76,   -76,   -76,   -76,   130,
     133,   138,   140,   141,   -76,   -76,   142,   -76,   151,    35,
     -76,   -76,   -76,   -76,   -76,   -76,   -76,   -76,   -76,   -76,
     -76,    35,   -76,   -76
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     1,     0,     6,     8,    10,     4,     3,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    25,    13,     0,    11,     0,     0,    14,
       0,    18,    19,    20,    22,    21,    16,    17,    32,    31,
      30,    24,    23,     5,    12,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    42,     0,    46,     0,     0,
      54,    56,    58,    35,     0,    33,     0,     0,     0,    29,
       0,    49,    39,    36,    40,    41,    37,    38,    65,    50,
      51,    52,     0,    45,     0,    48,    44,     0,     0,     7,
      34,     9,    27,    28,    26,    15,     0,     0,     0,    72,
       0,    66,    61,    59,    60,    43,    64,    62,    63,    47,
      73,    73,    71,    69,    70,    68,    53,    67,    77,     0,
       0,     0,     0,     0,    84,    76,     0,    74,     0,     0,
      79,    80,    82,    81,    83,    55,    75,    57,    87,    88,
      89,    78,    85,    86
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -76,   -76,   -76,   -76,   -76,   -76,   154,   -76,   -76,   152,
     -23,   -76,   -76,   -76,   -76,   -76,   -76,   -76,    89,    75,
     -75,   -76,   -76,    46
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     1,     8,    10,    11,    25,    26,    70,    41,    64,
      65,    82,    84,    87,    88,   105,   109,   100,   101,   126,
     127,   129,   141,   142
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
       2,    74,    75,     3,     4,    67,    68,    38,    39,    12,
      13,    40,    14,    96,    29,    15,    96,    16,    17,    18,
      69,     9,    92,    19,    93,    20,    27,    97,    98,    28,
      97,    98,    30,     5,     6,    21,    22,   113,    23,   114,
       7,    90,    99,    90,    24,    99,    43,    45,    46,    47,
     116,   136,    48,   136,    31,   102,    49,    50,    51,   103,
     104,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,   138,   139,   140,    62,    32,    45,    46,    47,   106,
      63,    48,    89,   107,   108,    49,    50,    51,    33,    34,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      35,    37,    36,    62,    12,    13,    42,    14,    73,    63,
      15,    91,    16,    17,    18,    71,    72,    76,    19,    77,
      20,    78,    79,    80,    81,    83,    85,    45,    46,    47,
      21,    22,    48,    23,    86,    94,    49,    50,    51,    24,
      95,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,   110,   118,   119,    62,   120,   121,   122,   111,   112,
      63,   118,   119,   115,   120,   121,   122,   130,   118,   119,
     131,   120,   121,   122,   123,   132,   124,   133,   134,    44,
      66,     0,   125,   123,   135,   124,   128,   143,     0,   117,
     123,   125,   124,   137,     0,     0,     0,     0,   125
};

static const yytype_int16 yycheck[] =
{
       0,    38,    39,     3,     4,    19,    20,    34,    35,     5,
       6,    38,     8,     5,    38,    11,     5,    13,    14,    15,
      34,    41,    35,    19,    37,    21,    41,    19,    20,    41,
      19,    20,    41,    33,    34,    31,    32,    35,    34,    37,
      40,    64,    34,    66,    40,    34,    42,     7,     8,     9,
      42,   126,    12,   128,    38,    34,    16,    17,    18,    38,
      39,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    36,    37,    38,    34,    36,     7,     8,     9,    34,
      40,    12,    42,    38,    39,    16,    17,    18,    36,    36,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      36,    38,    37,    34,     5,     6,    36,     8,    35,    40,
      11,    42,    13,    14,    15,    38,    38,    35,    19,    38,
      21,    41,    38,    38,    38,    38,    38,     7,     8,     9,
      31,    32,    12,    34,    38,    35,    16,    17,    18,    40,
      42,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    41,    10,    11,    34,    13,    14,    15,    41,    38,
      40,    10,    11,    35,    13,    14,    15,    37,    10,    11,
      37,    13,    14,    15,    32,    37,    34,    37,    37,    25,
      28,    -1,    40,    32,    42,    34,   111,   141,    -1,   100,
      32,    40,    34,    42,    -1,    -1,    -1,    -1,    40
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    44,     0,     3,     4,    33,    34,    40,    45,    41,
      46,    47,     5,     6,     8,    11,    13,    14,    15,    19,
      21,    31,    32,    34,    40,    48,    49,    41,    41,    38,
      41,    38,    36,    36,    36,    36,    37,    38,    34,    35,
      38,    51,    36,    42,    49,     7,     8,     9,    12,    16,
      17,    18,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    34,    40,    52,    53,    52,    19,    20,    34,
      50,    38,    38,    35,    38,    39,    35,    38,    41,    38,
      38,    38,    54,    38,    55,    38,    38,    56,    57,    42,
      53,    42,    35,    37,    35,    42,     5,    19,    20,    34,
      60,    61,    34,    38,    39,    58,    34,    38,    39,    59,
      41,    41,    38,    35,    37,    35,    42,    61,    10,    11,
      13,    14,    15,    32,    34,    40,    62,    63,    62,    64,
      37,    37,    37,    37,    37,    42,    63,    42,    36,    37,
      38,    65,    66,    66
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    43,    44,    44,    45,    45,    46,    45,    47,    45,
      45,    48,    48,    49,    49,    49,    49,    49,    49,    49,
      49,    49,    49,    49,    49,    49,    50,    50,    50,    50,
      51,    51,    51,    52,    52,    53,    53,    53,    53,    53,
      53,    53,    54,    53,    53,    53,    55,    53,    53,    53,
      53,    53,    53,    53,    56,    53,    57,    53,    53,    58,
      58,    58,    59,    59,    59,    60,    60,    60,    61,    61,
      61,    61,    61,    62,    62,    62,    63,    64,    63,    63,
      63,    63,    63,    63,    63,    65,    65,    66,    66,    66
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     1,     4,     0,     5,     0,     5,
       1,     1,     2,     1,     2,     4,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     2,     2,     2,     1,
       1,     1,     1,     1,     2,     1,     2,     2,     2,     2,
       2,     2,     0,     3,     2,     2,     0,     3,     2,     2,
       2,     2,     2,     4,     0,     5,     0,     5,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     2,     2,     2,
       2,     2,     1,     0,     1,     2,     1,     0,     3,     2,
       2,     2,     2,     2,     1,     1,     2,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 6: /* $@1: %empty  */
#line 93 "cfg_file.y"
                { 
		  parse_host = &default_host; 
                }
#line 1311 "cfg_file.tab.c"
    break;

  case 8: /* $@2: %empty  */
#line 98 "cfg_file.y"
                { 
		  if( !(parse_host = malloc(sizeof(struct vtun_host))) ){
		     yyerror("No memory for the host");
		     YYABORT;
		  }

		  /* Fill new host struct with default values.
		   * MUST dup strings to be able to reread config.
		   */
	  	  memcpy(parse_host, &default_host, sizeof(struct vtun_host));
		  parse_host->host = strdup((yyvsp[0].str));
		  parse_host->passwd = NULL;
		  parse_host->sopt.host = strdup((yyvsp[0].str));

		  /* Copy local address */
		  copy_addr(parse_host, &default_host);

		  llist_copy(&default_host.up,&parse_host->up,cp_cmd,NULL);
		  llist_copy(&default_host.down,&parse_host->down,cp_cmd,NULL);

		}
#line 1337 "cfg_file.tab.c"
    break;

  case 9: /* statement: K_HOST $@2 '{' host_options '}'  */
#line 120 "cfg_file.y"
                {
		  /* Check if session definition is complete */ 
		  if (!parse_host->passwd) {
		  	cfg_error("Ignored incomplete session definition '%s'", parse_host->host);
			free_host(parse_host, NULL);			
			free(parse_host);
		  } else {
		  	/* Add host to the list */
		  	llist_add(&host_list, (void *)parse_host);
		  }
		}
#line 1353 "cfg_file.tab.c"
    break;

  case 10: /* statement: K_ERROR  */
#line 132 "cfg_file.y"
                {
		  cfg_error("Invalid clause '%s'",(yyvsp[0].str));
		  YYABORT;
		}
#line 1362 "cfg_file.tab.c"
    break;

  case 14: /* option: K_PORT NUM  */
#line 145 "cfg_file.y"
                        { 
			  if(vtun.bind_addr.port == -1)
			     vtun.bind_addr.port = (yyvsp[0].num);
			}
#line 1371 "cfg_file.tab.c"
    break;

  case 16: /* option: K_IFACE STRING  */
#line 152 "cfg_file.y"
                        { 
			  if(vtun.svr_addr == NULL)
			    vtun.svr_addr = strdup((yyvsp[0].str));
			}
#line 1380 "cfg_file.tab.c"
    break;

  case 17: /* option: K_TYPE NUM  */
#line 157 "cfg_file.y"
                        { 
			  if(vtun.svr_type == -1)
			     vtun.svr_type = (yyvsp[0].num);
			}
#line 1389 "cfg_file.tab.c"
    break;

  case 18: /* option: K_TIMEOUT NUM  */
#line 162 "cfg_file.y"
                        {  
			  if(vtun.timeout == -1)
			     vtun.timeout = (yyvsp[0].num); 	
			}
#line 1398 "cfg_file.tab.c"
    break;

  case 19: /* option: K_PPP PATH  */
#line 167 "cfg_file.y"
                        {
			  free(vtun.ppp);
			  vtun.ppp = strdup((yyvsp[0].str));
			}
#line 1407 "cfg_file.tab.c"
    break;

  case 20: /* option: K_IFCFG PATH  */
#line 172 "cfg_file.y"
                        {
			  free(vtun.ifcfg);
			  vtun.ifcfg = strdup((yyvsp[0].str));
			}
#line 1416 "cfg_file.tab.c"
    break;

  case 21: /* option: K_ROUTE PATH  */
#line 177 "cfg_file.y"
                        {   
			  free(vtun.route);  
			  vtun.route = strdup((yyvsp[0].str)); 	
			}
#line 1425 "cfg_file.tab.c"
    break;

  case 22: /* option: K_FWALL PATH  */
#line 182 "cfg_file.y"
                        {   
			  free(vtun.fwall);  
			  vtun.fwall = strdup((yyvsp[0].str)); 	
			}
#line 1434 "cfg_file.tab.c"
    break;

  case 23: /* option: K_IPROUTE PATH  */
#line 187 "cfg_file.y"
                        {   
			  free(vtun.iproute);  
			  vtun.iproute = strdup((yyvsp[0].str)); 	
			}
#line 1443 "cfg_file.tab.c"
    break;

  case 25: /* option: K_ERROR  */
#line 194 "cfg_file.y"
                        {
			  cfg_error("Unknown option '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1452 "cfg_file.tab.c"
    break;

  case 26: /* bindaddr_option: K_ADDR WORD  */
#line 201 "cfg_file.y"
                        {
			  vtun.bind_addr.name = strdup((yyvsp[0].str));
			  vtun.bind_addr.type = VTUN_ADDR_NAME;
			}
#line 1461 "cfg_file.tab.c"
    break;

  case 27: /* bindaddr_option: K_IFACE WORD  */
#line 206 "cfg_file.y"
                        {
			  vtun.bind_addr.name = strdup((yyvsp[0].str));
			  vtun.bind_addr.type = VTUN_ADDR_IFACE;
			}
#line 1470 "cfg_file.tab.c"
    break;

  case 28: /* bindaddr_option: K_IFACE STRING  */
#line 211 "cfg_file.y"
                        {
			  vtun.bind_addr.name = strdup((yyvsp[0].str));
			  vtun.bind_addr.type = VTUN_ADDR_IFACE;
			}
#line 1479 "cfg_file.tab.c"
    break;

  case 29: /* bindaddr_option: K_ERROR  */
#line 216 "cfg_file.y"
                        {
			  cfg_error("Unknown option '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1488 "cfg_file.tab.c"
    break;

  case 30: /* syslog_opt: NUM  */
#line 223 "cfg_file.y"
                        {
                          vtun.syslog = (yyvsp[0].num);
  			}
#line 1496 "cfg_file.tab.c"
    break;

  case 31: /* syslog_opt: WORD  */
#line 227 "cfg_file.y"
                        {
                          if (parse_syslog((yyvsp[0].str))) {
                            cfg_error("Unknown syslog facility '%s'", (yyvsp[0].str));
                            YYABORT;
                          }
                        }
#line 1507 "cfg_file.tab.c"
    break;

  case 32: /* syslog_opt: K_ERROR  */
#line 234 "cfg_file.y"
                        {
   			  cfg_error("Unknown syslog option '%s'",(yyvsp[0].str));
  			  YYABORT;
			}
#line 1516 "cfg_file.tab.c"
    break;

  case 36: /* host_option: K_PASSWD WORD  */
#line 248 "cfg_file.y"
                        {
			  free(parse_host->passwd);
			  parse_host->passwd = strdup((yyvsp[0].str));
			}
#line 1525 "cfg_file.tab.c"
    break;

  case 37: /* host_option: K_DEVICE WORD  */
#line 253 "cfg_file.y"
                        {
			  free(parse_host->dev);
			  parse_host->dev = strdup((yyvsp[0].str));
			}
#line 1534 "cfg_file.tab.c"
    break;

  case 38: /* host_option: K_MULTI NUM  */
#line 258 "cfg_file.y"
                        { 
			  parse_host->multi = (yyvsp[0].num);
			}
#line 1542 "cfg_file.tab.c"
    break;

  case 39: /* host_option: K_TIMEOUT NUM  */
#line 262 "cfg_file.y"
                        { 
			  parse_host->timeout = (yyvsp[0].num);
			}
#line 1550 "cfg_file.tab.c"
    break;

  case 40: /* host_option: K_SPEED NUM  */
#line 266 "cfg_file.y"
                        { 
			  if( (yyvsp[0].num) ){ 
			     parse_host->spd_in = parse_host->spd_out = (yyvsp[0].num);
			     parse_host->flags |= VTUN_SHAPE;
			  } else 
			     parse_host->flags &= ~VTUN_SHAPE;
			}
#line 1562 "cfg_file.tab.c"
    break;

  case 41: /* host_option: K_SPEED DNUM  */
#line 274 "cfg_file.y"
                        { 
			  if( yylval.dnum.num1 || yylval.dnum.num2 ){ 
			     parse_host->spd_out = yylval.dnum.num1;
		             parse_host->spd_in = yylval.dnum.num2; 	
			     parse_host->flags |= VTUN_SHAPE;
			  } else 
			     parse_host->flags &= ~VTUN_SHAPE;
			}
#line 1575 "cfg_file.tab.c"
    break;

  case 42: /* $@3: %empty  */
#line 283 "cfg_file.y"
                        {
			  parse_host->flags &= ~(VTUN_ZLIB | VTUN_LZO); 
			}
#line 1583 "cfg_file.tab.c"
    break;

  case 44: /* host_option: K_SSLAUTH NUM  */
#line 288 "cfg_file.y"
                        { 
	      		  parse_host->sslauth = (yyvsp[0].num);

			  if(vtun.sslauth == -1) 
			     vtun.sslauth = (yyvsp[0].num); 	
			}
#line 1594 "cfg_file.tab.c"
    break;

  case 45: /* host_option: K_ENCRYPT NUM  */
#line 295 "cfg_file.y"
                        {  
			  if( (yyvsp[0].num) ){
			     parse_host->flags |= VTUN_ENCRYPT;
			     parse_host->cipher = (yyvsp[0].num);
			  } else
			     parse_host->flags &= ~VTUN_ENCRYPT;
			}
#line 1606 "cfg_file.tab.c"
    break;

  case 46: /* $@4: %empty  */
#line 303 "cfg_file.y"
                        {
			  parse_host->flags &= ~VTUN_KEEP_ALIVE; 
			}
#line 1614 "cfg_file.tab.c"
    break;

  case 48: /* host_option: K_STAT NUM  */
#line 308 "cfg_file.y"
                        {
			  if( (yyvsp[0].num) )
			     parse_host->flags |= VTUN_STAT;
			  else
			     parse_host->flags &= ~VTUN_STAT;
			}
#line 1625 "cfg_file.tab.c"
    break;

  case 49: /* host_option: K_PERSIST NUM  */
#line 315 "cfg_file.y"
                        { 
	      		  parse_host->persist = (yyvsp[0].num);

			  if(vtun.persist == -1) 
			     vtun.persist = (yyvsp[0].num); 	
			}
#line 1636 "cfg_file.tab.c"
    break;

  case 50: /* host_option: K_TYPE NUM  */
#line 322 "cfg_file.y"
                        {  
			  parse_host->flags &= ~VTUN_TYPE_MASK;
			  parse_host->flags |= (yyvsp[0].num);
			}
#line 1645 "cfg_file.tab.c"
    break;

  case 51: /* host_option: K_PROT NUM  */
#line 327 "cfg_file.y"
                        {  
			  parse_host->flags &= ~VTUN_PROT_MASK;
			  parse_host->flags |= (yyvsp[0].num);
			}
#line 1654 "cfg_file.tab.c"
    break;

  case 52: /* host_option: K_NAT_HACK NUM  */
#line 332 "cfg_file.y"
                        {  
#ifdef ENABLE_NAT_HACK
			  parse_host->flags &= ~VTUN_NAT_HACK_MASK;
			  parse_host->flags |= (yyvsp[0].num);
#else
			  cfg_error("This vtund binary was built with the NAT hack disabled for security purposes.");
#endif
			}
#line 1667 "cfg_file.tab.c"
    break;

  case 54: /* $@5: %empty  */
#line 343 "cfg_file.y"
                        { 
			  parse_cmds = &parse_host->up; 
   			  llist_free(parse_cmds, free_cmd, NULL);   
			}
#line 1676 "cfg_file.tab.c"
    break;

  case 56: /* $@6: %empty  */
#line 348 "cfg_file.y"
                        { 
			  parse_cmds = &parse_host->down; 
   			  llist_free(parse_cmds, free_cmd, NULL);   
			}
#line 1685 "cfg_file.tab.c"
    break;

  case 58: /* host_option: K_ERROR  */
#line 353 "cfg_file.y"
                        {
			  cfg_error("Unknown option '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1694 "cfg_file.tab.c"
    break;

  case 59: /* compress: NUM  */
#line 360 "cfg_file.y"
                        { 
			  if( (yyvsp[0].num) ){  
      			     parse_host->flags |= VTUN_ZLIB; 
			     parse_host->zlevel = (yyvsp[0].num);
			  }
			}
#line 1705 "cfg_file.tab.c"
    break;

  case 60: /* compress: DNUM  */
#line 367 "cfg_file.y"
                        {
			  parse_host->flags |= yylval.dnum.num1;
		          parse_host->zlevel = yylval.dnum.num2;
  			}
#line 1714 "cfg_file.tab.c"
    break;

  case 61: /* compress: K_ERROR  */
#line 372 "cfg_file.y"
                        {
			  cfg_error("Unknown compression '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1723 "cfg_file.tab.c"
    break;

  case 62: /* keepalive: NUM  */
#line 379 "cfg_file.y"
                        { 
			  if( (yyvsp[0].num) )
			     parse_host->flags |= VTUN_KEEP_ALIVE;
			}
#line 1732 "cfg_file.tab.c"
    break;

  case 63: /* keepalive: DNUM  */
#line 384 "cfg_file.y"
                        {
			  if( yylval.dnum.num1 ){
			     parse_host->flags |= VTUN_KEEP_ALIVE;
			     parse_host->ka_interval = yylval.dnum.num1;
		             parse_host->ka_maxfail  = yylval.dnum.num2;
			  }
  			}
#line 1744 "cfg_file.tab.c"
    break;

  case 64: /* keepalive: K_ERROR  */
#line 392 "cfg_file.y"
                        {
			  cfg_error("Unknown keepalive option '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1753 "cfg_file.tab.c"
    break;

  case 68: /* srcaddr_option: K_ADDR WORD  */
#line 404 "cfg_file.y"
                        {
			  free_addr(parse_host);
			  parse_host->src_addr.name = strdup((yyvsp[0].str));
			  parse_host->src_addr.type = VTUN_ADDR_NAME;
			}
#line 1763 "cfg_file.tab.c"
    break;

  case 69: /* srcaddr_option: K_IFACE WORD  */
#line 410 "cfg_file.y"
                        {
			  free_addr(parse_host);
			  parse_host->src_addr.name = strdup((yyvsp[0].str));
			  parse_host->src_addr.type = VTUN_ADDR_IFACE;
			}
#line 1773 "cfg_file.tab.c"
    break;

  case 70: /* srcaddr_option: K_IFACE STRING  */
#line 416 "cfg_file.y"
                        {
			  free_addr(parse_host);
			  parse_host->src_addr.name = strdup((yyvsp[0].str));
			  parse_host->src_addr.type = VTUN_ADDR_IFACE;
			}
#line 1783 "cfg_file.tab.c"
    break;

  case 71: /* srcaddr_option: K_PORT NUM  */
#line 422 "cfg_file.y"
                        {
			  parse_host->src_addr.port = (yyvsp[0].num);
			}
#line 1791 "cfg_file.tab.c"
    break;

  case 72: /* srcaddr_option: K_ERROR  */
#line 426 "cfg_file.y"
                        {
			  cfg_error("Unknown option '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1800 "cfg_file.tab.c"
    break;

  case 77: /* $@7: %empty  */
#line 438 "cfg_file.y"
                        {
			  memset(&parse_cmd, 0, sizeof(struct vtun_cmd));
			}
#line 1808 "cfg_file.tab.c"
    break;

  case 78: /* command_option: K_PROG $@7 prog_options  */
#line 441 "cfg_file.y"
                        {
			  add_cmd(parse_cmds, parse_cmd.prog, 
				  parse_cmd.args, parse_cmd.flags);
			}
#line 1817 "cfg_file.tab.c"
    break;

  case 79: /* command_option: K_PPP STRING  */
#line 446 "cfg_file.y"
                        {   
			  add_cmd(parse_cmds, strdup(vtun.ppp), strdup((yyvsp[0].str)), 
					VTUN_CMD_DELAY);
			}
#line 1826 "cfg_file.tab.c"
    break;

  case 80: /* command_option: K_IFCFG STRING  */
#line 451 "cfg_file.y"
                        {   
			  add_cmd(parse_cmds, strdup(vtun.ifcfg),strdup((yyvsp[0].str)),
					VTUN_CMD_WAIT);
			}
#line 1835 "cfg_file.tab.c"
    break;

  case 81: /* command_option: K_ROUTE STRING  */
#line 456 "cfg_file.y"
                        {   
			  add_cmd(parse_cmds, strdup(vtun.route),strdup((yyvsp[0].str)),
					VTUN_CMD_WAIT);
			}
#line 1844 "cfg_file.tab.c"
    break;

  case 82: /* command_option: K_FWALL STRING  */
#line 461 "cfg_file.y"
                        {   
			  add_cmd(parse_cmds, strdup(vtun.fwall),strdup((yyvsp[0].str)),
					VTUN_CMD_WAIT);
			}
#line 1853 "cfg_file.tab.c"
    break;

  case 83: /* command_option: K_IPROUTE STRING  */
#line 466 "cfg_file.y"
                        {   
			  add_cmd(parse_cmds, strdup(vtun.iproute),strdup((yyvsp[0].str)),
					VTUN_CMD_WAIT);
			}
#line 1862 "cfg_file.tab.c"
    break;

  case 84: /* command_option: K_ERROR  */
#line 471 "cfg_file.y"
                        {
			  cfg_error("Unknown cmd '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1871 "cfg_file.tab.c"
    break;

  case 87: /* prog_option: PATH  */
#line 483 "cfg_file.y"
                        {
			  parse_cmd.prog = strdup((yyvsp[0].str));
			}
#line 1879 "cfg_file.tab.c"
    break;

  case 88: /* prog_option: STRING  */
#line 487 "cfg_file.y"
                        {
			  parse_cmd.args = strdup((yyvsp[0].str));
			}
#line 1887 "cfg_file.tab.c"
    break;

  case 89: /* prog_option: NUM  */
#line 491 "cfg_file.y"
                        {
			  parse_cmd.flags = (yyvsp[0].num);
			}
#line 1895 "cfg_file.tab.c"
    break;


#line 1899 "cfg_file.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 495 "cfg_file.y"


int yyerror(char *s) 
{
   vtun_syslog(LOG_ERR, "%s line %d\n", s, lineno);
   return 0;
}

int cfg_error(const char *fmt, ...)
{
   char buf[255];
   va_list ap;

   /* print the argument string */
   va_start(ap, fmt);
   vsnprintf(buf,sizeof(buf),fmt,ap);
   va_end(ap);

   yyerror(buf);
   return 0;
}

int add_cmd(llist *cmds, char *prog, char *args, int flags)
{
   struct vtun_cmd *cmd;
   if( !(cmd = malloc(sizeof(struct vtun_cmd))) ){
      yyerror("No memory for the command");
      return -1;
   }
   memset(cmd, 0, sizeof(struct vtun_cmd)); 		   			

   cmd->prog = prog;
   cmd->args = args;
   cmd->flags = flags;
   llist_add(cmds, cmd);

   return 0;
}		

void *cp_cmd(void *d, void *u)
{
   struct vtun_cmd *cmd = d, *cmd_copy; 

   if( !(cmd_copy = malloc(sizeof(struct vtun_cmd))) ){
      yyerror("No memory to copy the command");
      return NULL;
   }
 
   cmd_copy->prog = strdup(cmd->prog);
   cmd_copy->args = strdup(cmd->args);
   cmd_copy->flags = cmd->flags;
   return cmd_copy;
}

int free_cmd(void *d, void *u)
{
   struct vtun_cmd *cmd = d; 
   free(cmd->prog);
   free(cmd->args);
   free(cmd);
   return 0;
}

void copy_addr(struct vtun_host *to, struct vtun_host *from)
{  
   if( from->src_addr.type ){
      to->src_addr.type = from->src_addr.type;
      to->src_addr.name = strdup(from->src_addr.name);
   }
   to->src_addr.port = from->src_addr.port;
}

void free_addr(struct vtun_host *h)
{  
   if( h->src_addr.type ){
      h->src_addr.type = 0;
      free(h->src_addr.name);
   }
}

int free_host(void *d, void *u)
{
   struct vtun_host *h = d;

   if (u && !strcmp(h->host, u))
      return 1;

   free(h->host);   
   free(h->passwd);   
   
   llist_free(&h->up, free_cmd, NULL);   
   llist_free(&h->down, free_cmd, NULL);

   free_addr(h);

   /* releases only host struct instances which were
    * allocated in the case of K_HOST except default_host */
   if( h->passwd )
      free(h);

 
   return 0;   
}

/* Find host in the hosts list.
 * NOTE: This function can be called only once since it deallocates hosts list.
 */ 
inline struct vtun_host* find_host(char *host)
{
   return (struct vtun_host *)llist_free(&host_list, free_host, host);
}

int clear_nat_hack_server(void *d, void *u)
{
	((struct vtun_host*)d)->flags &= ~VTUN_NAT_HACK_CLIENT;
	return 0;
}

int clear_nat_hack_client(void *d, void *u)
{
	((struct vtun_host*)d)->flags &= ~VTUN_NAT_HACK_SERVER;
	return 0;
}

/* Clear the VTUN_NAT_HACK flag which are not relevant to the current operation mode */
void clear_nat_hack_flags(int svr)
{
	if (svr)
		llist_trav(&host_list,clear_nat_hack_server,NULL);
	else 
		llist_trav(&host_list,clear_nat_hack_client,NULL);
}

inline void free_host_list(void)
{
   llist_free(&host_list, free_host, NULL);
}

static struct {
   char *c_name;
   int  c_val;
} syslog_names[] = {
    { "auth",   LOG_AUTH },
    { "cron",   LOG_CRON },
    { "daemon", LOG_DAEMON },
    { "kern",   LOG_KERN },
    { "lpr",    LOG_LPR },
    { "mail",   LOG_MAIL },
    { "news",   LOG_NEWS },
    { "syslog", LOG_SYSLOG },
    { "user",   LOG_USER },
    { "uucp",   LOG_UUCP },
    { "local0", LOG_LOCAL0 },
    { "local1", LOG_LOCAL1 },
    { "local2", LOG_LOCAL2 },
    { "local3", LOG_LOCAL3 },
    { "local4", LOG_LOCAL4 },
    { "local5", LOG_LOCAL5 },
    { "local6", LOG_LOCAL6 },
    { "local7", LOG_LOCAL7 },
    { NULL, -1 }
};

int parse_syslog(char *facility)
{
   int i;

   for (i=0; syslog_names[i].c_name;i++) {
      if (!strcmp(syslog_names[i].c_name, facility)) {
         vtun.syslog = syslog_names[i].c_val;
         return(0);
      }
   }
   return -1;
}

/* 
 * Read config file. 
 */ 
int read_config(char *file) 
{
   static int cfg_loaded = 0;
   extern FILE *yyin;

   if( cfg_loaded ){
      free_host_list();
      vtun_syslog(LOG_INFO,"Reloading configuration file");
   }	 
   cfg_loaded = 1;

   llist_init(&host_list);

   if( !(yyin = fopen(file,"r")) ){
      vtun_syslog(LOG_ERR,"Can not open %s", file);
      return -1;      
   }

   yyparse();

   free_host(&default_host, NULL);

   fclose(yyin);
  
   return !llist_empty(&host_list);     
}
